<?php

$themename = "Ultimate Baseball Theme";
$shortname = "Ultimate Baseball Theme";

if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<li><div class="widget">',
        'after_widget' => '</div></li>',
        'before_title' => '<h3 class="widgettitle">',
        'after_title' => '</h3>',
    ));

// custom header stuff

define( 'HEADER_TEXTCOLOR', '' );
define( 'HEADER_IMAGE', '%s/images/bg_top.jpg' ); // %s is theme dir uri
define( 'HEADER_IMAGE_WIDTH', 1280 );
define( 'HEADER_IMAGE_HEIGHT', 134 );
define( 'NO_HEADER_TEXT', true );
define( 'HEADER_IMG_DIR', 'ultimatebaseball' );
define( 'BLOG_REL_PATH', str_replace($_SERVER['DOCUMENT_ROOT'], '', ABSPATH) );



add_custom_image_header( 'addHeaderImage', 'adminHeaderStyle' );

function addHeaderImage() {
?>
<style type="text/css">
body #top {
background: url(<?php header_image() ?>) no-repeat center top;
}

#headimg {
width:1280px;
height:134px;
}

#headimg h1 {
display:none;
}
</style>
<?php }

function adminHeaderStyle() {
?>
<style type="text/css">
#headimg {
height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
width: <?php echo HEADER_IMAGE_WIDTH; ?>px;
}

#headimg h1, #headimg #desc {
display: none;
}
</style>
<?php }

// get_flickrRSS is adapted from http://eightface.com/wordpress/flickrrss/

function get_flickrRSS() {

	$default = 'redsox';
	$initialtags = get_option('flickrRSS_tags');

	# if there is no initial set of tags, set the default 
	if (!$initialtags) {
		update_option('flickrRSS_flickrid', '');
		update_option('flickrRSS_tags', $default);
	}

	// the function can accept up to four parameters, otherwise it uses option panel defaults 	
  	for($i = 0 ; $i < func_num_args(); $i++) {
    	$args[] = func_get_arg($i);
    	}
  	if (!isset($args[0])) $num_items = get_option('flickrRSS_display_numitems'); else $num_items = $args[0];
  	if (!isset($args[1])) $tags = trim(get_option('flickrRSS_tags')); else $tags = trim($args[1]);
  	if (!isset($args[2])) $imagesize = get_option('flickrRSS_display_imagesize'); else $imagesize = $args[2];
  	if (!isset($args[3])) $userid = stripslashes(get_option('flickrRSS_flickrid')); else $userid = $args[3];

	if (!function_exists('MagpieRSS')) { // Check if another plugin is using RSS, may not work
		include_once (ABSPATH . WPINC . '/rss.php');
		error_reporting(E_ERROR);
	}


	// get the feed
	$rss_url = 'http://api.flickr.com/services/feeds/photos_public.gne?id=' . $userid . '&tags=' . $tags . '&format=rss_200';

	# get rss file
	$rss = @ fetch_rss($rss_url);

	if ($rss) {
    	$imgurl = "";
    	# specifies number of pictures
		$items = array_slice($rss->items, 0, $num_items);

	    # builds html from array
    	foreach ( $items as $item ) {
       	 if(preg_match('<img src="([^"]*)" [^/]*/>', $item['description'],$imgUrlMatches)) {
            	$imgurl = $imgUrlMatches[1];
 
            #change image size         
           	if ($imagesize == "square") {
             	$imgurl = str_replace("m.jpg", "s.jpg", $imgurl);
           	} elseif ($imagesize == "thumbnail") {
             $imgurl = str_replace("m.jpg", "t.jpg", $imgurl);
           	}
           
           $title = htmlspecialchars(stripslashes($item['title']));
           $url = $item['link'];
	
	       preg_match('<http://farm[0-9]{0,3}\.static.flickr\.com/\d+?\/([^.]*)\.jpg>', $imgurl, $flickrSlugMatches);
	       $flickrSlug = $flickrSlugMatches[1];
	       
         print "<li><a target=\"blank\" href=\"$url\" title=\"$title\"><img src=\"$imgurl\" alt=\"$title\" /></a></li>";      
       } // end pregmatch
     } // end foreach
  } else {
    #print "Flickr is having a massage (Flickr Blog)";
  }
} # end get_flickrRSS() function

function get_feed() {
	$default = 'http://www.totallyscored.com/rss/team/82';
	$feedurl = get_option('getfeed_feedurl');
	
	# if there is no feed url yet, set the value to our default
	if (!$feedurl) {
		update_option('getfeed_feedurl', $default);
		$feedurl = get_option('getfeed_feedurl');
	}
	
	return $feedurl;
}

function uploadFile ($upload_dir, $field_name) { 
        if(!$_FILES[$field_name]['error'] && strlen($_FILES[$field_name]['name'])) {
                $tmp_name = $_FILES[$field_name]['tmp_name'];
                if(!file_exists($upload_dir)) { mkdir ($upload_dir, 0777); }
                $target_path = $upload_dir . '/' . $_FILES[$field_name]['name'];
                move_uploaded_file($tmp_name, $target_path);
                chmod ($target_path, 0666);
        }
}

function removeFile ($upload_dir, $file_name) {
	if(strlen($file_name) && file_exists($upload_dir . $file_name)) {
		unlink($upload_dir . $file_name);
	}
}

function ultimatebaseball_subpanel() {
	if (isset($_POST['save_flickrrss_options'])) {
       $option_flickrid = $_POST['flickr_nsid'];
       $option_tags = $_POST['tags'];
       $option_display_numitems = $_POST['display_numitems'];
       $option_display_imagesize = $_POST['display_imagesize'];
       update_option('flickrRSS_flickrid', $option_flickrid);
       update_option('flickrRSS_tags', $option_tags);
       update_option('flickrRSS_display_numitems', $option_display_numitems);
       update_option('flickrRSS_display_imagesize', $option_display_imagesize);
       ?> <div class="updated"><p>flickr option changes saved.</p></div> <?php
     }
     
	if (isset($_POST['save_feed_options'])) {
       $option_feedurl = $_POST['feedurl'];
       update_option('getfeed_feedurl', $option_feedurl);
       ?> <div class="updated"><p>Scoreboard Feed option changes saved.</p></div> <?php
     }

	if (isset($_POST['save_lead_story_img'])) {
		$error_msg = array();
		if(strlen($_FILES['lead_story_img']['name'])) {
			update_option('lead_story_img', $_FILES['lead_story_img']['name']);
		}

		// if upload path doesn't exist, try to create it
		// log error for user

		if(!file_exists(ABSPATH . get_option('upload_path'))) {
			mkdir (ABSPATH . get_option('upload_path'), 0777);
			if(!file_exists(ABSPATH . get_option('upload_path'))) {
				$error_msg[] = '<li>Unable to create upload dir manually, please create: ' . ABSPATH . get_option('upload_path') . '</li>';
			}
		}

		// upload the file and log error if the file doesn't exist after upload

		uploadFile(ABSPATH . get_option('upload_path') . '/' . HEADER_IMG_DIR . '/', 'lead_story_img');
		$file_location = ABSPATH . get_option('upload_path') . '/' . HEADER_IMG_DIR . '/' . $_FILES['lead_story_img']['name'];
		if(!file_exists($file_location)) {
			$error_msg[] = '<li>Unable to upload file. Unable to save to the following location: ' . $file_location . '</li>';
		}

		if(count($error_msg)) { $error_msg_str = '<ul>' . join('', $error_msg) . '</ul>'; }
	?> <div class="updated"><p>Lead Story Image changes saved.<?php echo $error_msg_str; ?></p></div> <?php
	}
	elseif ($_POST['remove_lead_img']) {
		update_option('lead_story_img', '');
		removeFile(ABSPATH . get_option('upload_path') . '/' . HEADER_IMG_DIR . '/', get_option('lead_story_img'));
        ?> <div class="updated"><p>Lead Story Image removed.</p></div> <?php
        }


	?>

	<div class="wrap">
		<h3>flickr Settings</h3>
		<form method="post">
		
		<table width="100%" class="editform form-table">
		 <tr>
		  <td><p><strong><label for="flickr_nsid">User ID</label>:</strong></p></td>
	      <td><input name="flickr_nsid" type="text" id="flickr_nsid" value="<?php echo get_option('flickrRSS_flickrid'); ?>" size="20" />
        		Use the <a href="http://idgettr.com">idGettr</a> to find the id for another account.</td>
         </tr>
         <tr>
          <td><p><strong>Display:</strong></p></td>
          <td>
        	<select name="display_numitems" id="display_numitems">
		      <option <?php if(get_option('flickrRSS_display_numitems') == '1') { echo 'selected'; } ?> value="1">1</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '2') { echo 'selected'; } ?> value="2">2</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '3') { echo 'selected'; } ?> value="3">3</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '4') { echo 'selected'; } ?> value="4">4</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '5') { echo 'selected'; } ?> value="5">5</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '6') { echo 'selected'; } ?> value="6">6</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '7') { echo 'selected'; } ?> value="7">7</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '8') { echo 'selected'; } ?> value="8">8</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '9') { echo 'selected'; } ?> value="9">9</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '10') { echo 'selected'; } ?> value="10">10</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '11') { echo 'selected'; } ?> value="11">11</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '12') { echo 'selected'; } ?> value="12">12</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '13') { echo 'selected'; } ?> value="13">13</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '14') { echo 'selected'; } ?> value="14">14</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '15') { echo 'selected'; } ?> value="15">15</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '16') { echo 'selected'; } ?> value="16">16</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '17') { echo 'selected'; } ?> value="17">17</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '18') { echo 'selected'; } ?> value="18">18</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '19') { echo 'selected'; } ?> value="19">19</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '20') { echo 'selected'; } ?> value="20">20</option>
		      </select>
            <select name="display_imagesize" id="display_imagesize">
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'square') { echo 'selected'; } ?> value="square">square</option>
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'thumbnail') { echo 'selected'; } ?> value="thumbnail">thumbnail</option>
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'small') { echo 'selected'; } ?> value="small">small</option>
		    </select>
            <label for="mediumImages">images</label></p>
           </td> 
         </tr>
         <tr>
		  <td><p><strong><label for="tag">Tags:</label></strong></p></td>
          <td><input name="tags" type="text" id="tags" value="<?php echo get_option('flickrRSS_tags'); ?>" size="40" /> Comma separated, no spaces</p>
         </tr>
         </table>

		<p><div class="submit"><input type="submit" name="save_flickrrss_options" value="<?php _e('Save Options', 'save_flickrrss_options') ?>"  style="font-weight:bold;" /></div></p>
        </form>
        
                <h3 style="padding-top:30px;">Lead Story Image Settings</h3>
                <form method="post" enctype="multipart/form-data">

                <table width="100%" class="editform form-table">
                 <tr>
                  <td><p><strong><label for="feedurl">Upload lead story image</label>:</strong></p></td>
<?php if(strlen(get_option('lead_story_img')) && file_exists(ABSPATH.get_option('upload_path') . '/' . HEADER_IMG_DIR . '/' . get_option('lead_story_img'))): ?>
<?php $lead_image_found = 1; ?>
<p><?php echo 'Current Image: ' . get_option('lead_story_img'); ?><br/>
<?php echo 'Path: ' . ABSPATH.get_option('upload_path') . '/' . HEADER_IMG_DIR . '/' . get_option('lead_story_img'); ?></p>
			<img src="<?php echo BLOG_REL_PATH.get_option('upload_path'); ?>/<?php echo HEADER_IMG_DIR; ?>/<?php echo get_option('lead_story_img'); ?>" />
<?php endif; ?>
              <td><input name="lead_story_img" type="file" id="lead_story_img" size="35" />
         </tr>
         </table>

                <p><div class="submit"><input type="submit" name="save_lead_story_img" value="<?php _e('Upload Image', 'save_lead_story_img') ?>" style="font-weight:bold;" /><?php if($lead_image_found): ?><input type="submit" name="remove_lead_img" value="<?php _e('Remove Image', 'remove_lead_img') ?>" style="font-weight:bold;" /><?php endif; ?></div></p>
        </form>

		<h3 style="padding-top:30px;">Scoreboard Feed Settings</h3>
		<form method="post">
		
		<table width="100%" class="editform form-table">
		 <tr>
		  <td><p><strong><label for="feedurl">Scoreboard Feed URL</label>:</strong></p></td>
	      <td><input name="feedurl" type="text" id="feedurl" value="<?php echo get_option('getfeed_feedurl'); ?>" size="35" />
        		Example: http://www.totallyscored.com/rss/team/82</td>
         </tr>
         </table>

		<p><div class="submit"><input type="submit" name="save_feed_options" value="<?php _e('Save Options', 'save_feed_options') ?>"  style="font-weight:bold;" /></div></p>
        </form>          
      
    </div>

<?php } // end subpanel()

function ultimatebaseball_admin_menu() {
   if (function_exists('add_theme_page')) {
        add_theme_page('', 'Ultimate Baseball Options', 8, basename(__FILE__), 'ultimatebaseball_subpanel');
        }
}

// let's run our functions in a buffer to establish defaults when the admin panel is first run

ob_start();
get_flickrRSS();
get_feed();
ob_end_clean();

// and finally, let's add the admin menu

add_action('admin_menu', 'ultimatebaseball_admin_menu'); 

?>
